/* Общий файл психики

*/
package psychic

import (
	"BOT/brain/action_sensor"
	wordSensor "BOT/brain/words_sensor"
)

///////////////////////////////
// инициализирующий блок - в порядке последовательности инициализаций
// после condition_reflex.go
func PsychicInit(){

	automatizmTreeInit()
	automatizmInit()
	emotionsInit()
	loadActivityInit()
	verbalInit()


//	SensorActivation(1,1,[]int{1})
}
/////////////////////////////////////////////////////////////


// ПУЛЬС психики
var psychicPulsCount=0 // передача тика Пульса из brine.go
func PsychicCountPuls(puls int){
	psychicPulsCount=puls // передача номера тика из более низкоуровневого пакета

/* обнулить блокировку действий рефлексов на 10 пульсов,
	чтобы на период оценки результата психа не мешали рефлексы
	хотя дерево рефлексов будет активироваться
 */
	if reflexActionsBlocingPuls>0 && reflexActionsBlocingPuls>(psychicPulsCount+10){
		reflexActionsBlocingPuls=0
	}
	if PsyActionImgPulsCount>0 && PsyActionImgPulsCount>(psychicPulsCount+100){
		PsyActionImg=ActivityFromIdArr[1]// образ бездействия
		PsyActionImgPulsCount=0
	}


}
//////////////////////////////////////////////////////////////

/* Среда условий текущего состояния - интегративная информационная среда

 */
var PsyBaseID=0 // текущее базовое состояние, может быть произвольно изменено
// текущая эмоция Emotion, может быть произвольно изменена
var PsyEmotionImg *Emotion
// текущий образ сочетания действий с Пульта Activity
var PsyActionImg *Activity // хранится до следующего любого действия или фразы с Пульта но не более 100 пусльсов
var PsyActionImgPulsCount=0// момент обновления
// текущий образ фразы с Пульта Verbal
var PsyVerbImg *Verbal



/////////////////////////////////////////////////////////////////
/*  активация по событиям с Пульта - из perception.go
Для блокировки активации дерева рефлексов вернуть true
 */
func SensorActivation(activationType int,badNormalWell int,bsIDarr []int)(bool){
	PsyBaseID=badNormalWell // текущее базовое состояние, может быть произвольно изменено
	_,PsyEmotionImg=createNewBaseStyle(0,bsIDarr) // текущая эмоция Emotion, может быть произвольно изменена
	ActID:=action_sensor.CheckCurActions()
	_,PsyActionImg=createNewlastActivityID(0,ActID)// текущий образ сочетания действий с Пульта Activity
	PsyActionImgPulsCount=psychicPulsCount// момент обновления
	// текущий массив фразID (DetectedUnicumPhraseID) с контекстным окружением
	PhraseID:=wordSensor.CurrentPhrasesIDarr
	if PhraseID!=nil {
		ToneID := wordSensor.DetectedTone
		MoodID := wordSensor.CurPultMood
		_,PsyVerbImg= CreateVerbalImage(PhraseID, ToneID, MoodID)
	}

atomatizmID:=automatizmTreeActivation()
if atomatizmID>0{
	return true
}


	return false
}
/////////////////////////////////////////////////////////////////



